/***************************************************************************
 $RCSfile$
                             -------------------
    cvs         : $Id$
    begin       : Mon Mar 01 2004
    copyright   : (C) 2004 by Martin Preuss
    email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/

#ifndef AQBANKING_KDE_ASKACCOUNT_H
#define AQBANKING_KDE_ASKACCOUNT_H

class AccountListView;
class Account;
class KBanking;



#include "askaccount.ui.h"
#include <qstring.h>

#include <aqbanking/account.h>



class AskAccount: public AskAccountUi {
  Q_OBJECT
public:
  AskAccount(KBanking *app,
             const char *bankCode,
	     const char *accountId,
	     const char *accountName,
             AB_ACCOUNT_TYPE t,
             QWidget* parent=0,
             const char* name=0,
             bool modal=FALSE,
             WFlags fl=0);
  ~AskAccount();

  Account *selectedAccount();

public slots:
  void accept();
  void reject();

  void slotCreateAccount();
  void slotHelp();

private:
  KBanking *_app;
  AccountListView *_accountList;
  QString _bankCode;
  QString _accountId;
  QString _accountName;
  AB_ACCOUNT_TYPE _accountType;
};






#endif // AQBANKING_KDE_ASKACCOUNT_H

