/***************************************************************************
 $RCSfile$
                             -------------------
    cvs         : $Id$
    begin       : Mon Mar 01 2004
    copyright   : (C) 2004 by Martin Preuss
    email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/



#ifndef KBANKING_REPORTVIEW_H
#define KBANKING_REPORTVIEW_H

#include "reportview.ui.h"

#include <gwenhywfar/db.h>



class KBanking;
class Report;


class ReportView: public ReportViewUi {
  Q_OBJECT
private:
  KBanking *_app;
  Report *_currentReport;

  GWEN_DB_NODE *getSelectedProfile();

public:
  ReportView(KBanking *app,
             QWidget* parent=0,
             const char* name=0,
             WFlags fl=0);
  ~ReportView();

  bool init();
  bool fini();

  void update();
  void updateProfiles();

public slots:
  void slotReportTypeChanged(int idx);
  void slotProfileSectionChanged();

  void slotUseProfile();
  void slotNewProfile();
  void slotCopyProfile();
  void slotEditProfile();
  void slotDeleteProfile();
  void slotDetailsProfile();
};




#endif

